module RailsAdmin
  module Config
    module Actions
      class Approve < RailsAdmin::Config::Actions::Base
        RailsAdmin::Config::Actions.register(self)

        register_instance_option(:visible?) do
          authorized? and bindings[:object].respond_to? :state_cd and bindings[:object].state_cd == 0
        end

        register_instance_option(:member) { true }
        register_instance_option(:link_icon) { 'icon-check' }
        register_instance_option(:pjax?) { false }

        register_instance_option :controller do
          Proc.new do

            if @object.state_cd == 0
              @object.update_attribute(:state_cd, 1)
              flash[:notice] = t 'admin.actions.approve.done',
                                 model_label:@abstract_model.model_name,
                                 object_label: @object.send(@model_config.object_label_method)
            else
              flash[:error] = t 'admin.actions.approve.not_available',
                                model_label:@abstract_model.model_name,
                                object_label: @object.send(@model_config.object_label_method)
            end

            redirect_to back_or_index
          end
        end

      end
    end
  end
end